/***************************************************************************
 *            binomial coefficient.c
 *
 *  Sun Nov  4 18:15:42 2007
 *  Copyright  2007  pchero21
 *  pchero21@gmail.com
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#include <stdio.h>

int minimum(int n, int k)
{
	if(n > k)
		return k;
	else
		return n;
}

int bin2(int n, int k)
{
	int i, j;
	int B[n + 1][k + 1];
	
	for(i = 0; i <= n; i++) {
		for(j = 0; j <= minimum(i, k); j++) {
			if(j == 0 || j == i)
				B[i][j] = 1;
			else
				B[i][j] = B[i - 1][j - 1] + B[i - 1][j];
		}
	}
	return B[n][k];
}

int main()
{
	int num_i, num_j, num_result;
	
	printf("Insert biomial number...\n");
	printf("Insert : ");
	
	scanf("%d %d", &num_i, &num_j);
	
	printf("\n\nNow loading...\n");
	num_result = bin2(num_i, num_j);
	printf("Result : %d\n", num_result);
	
	return 0;
}
